VMPlugin (Groovy 2.4.10)
Date: 2017-03-14

org.codehaus.groovy.vmplugin

## Interface VMPlugin

- All Known Implementing Classes:
    Java5, Java6, Java7

      public interface VMPlugin

  Interface to access VM version based actions. This interface is for internal use only!
  Author:
    Jochen Theodorou

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configureAnnotation(AnnotationNode an)`
    `void` | `configureClassNode(CompileUnit compileUnit, ClassNode classNode)`
    `Object` | `getInvokeSpecialHandle(Method m, Object receiver)` Returns a handle with bound receiver to invokeSpecial the given method.
    `Class[]` | `getPluginDefaultGroovyMethods()`
    `Class[]` | `getPluginStaticGroovyMethods()`
    `int` | `getVersion()` Gives the version the plguin is made for
    `void` | `invalidateCallSites()`
    `Object` | `invokeHandle(Object handle, Object[] args)` Invokes a handle produced by #getInvokeSpecialdHandle
    `void` | `setAdditionalClassInformation(ClassNode c)`

- - ### Method Detail

    - #### setAdditionalClassInformation

          void setAdditionalClassInformation(ClassNode c)

    - #### getPluginDefaultGroovyMethods

          Class[] getPluginDefaultGroovyMethods()

    - #### getPluginStaticGroovyMethods

          Class[] getPluginStaticGroovyMethods()

    - #### configureAnnotation

          void configureAnnotation(AnnotationNode an)

    - #### configureClassNode

          void configureClassNode(CompileUnit compileUnit,
                                  ClassNode classNode)

    - #### invalidateCallSites

          void invalidateCallSites()

    - #### getInvokeSpecialHandle

          Object getInvokeSpecialHandle(Method m,
                                        Object receiver)

      Returns a handle with bound receiver to invokeSpecial the given method. This method will require at least Java 7, but since the source has to compile on older Java versions as well it is not marked to return a MethodHandle and uses Object instead
      Returns:
        null in case of jdk<7, otherwise a handle that takes the method call arguments for the invokespecial call

    - #### invokeHandle

          Object invokeHandle(Object handle,
                              Object[] args)
                       throws Throwable

      Invokes a handle produced by #getInvokeSpecialdHandle
      Parameters:
        `handle` - the handle
        `args` - arguments for the method call, can be empty but not null
      Returns:
        the result of the method call
      Throws:
        `Throwable`

    - #### getVersion

          int getVersion()

      Gives the version the plguin is made for
      Returns:
        5 for jdk5, 6 for jdk6, 7 for jdk7 or higher